<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: memory/basic_list.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_267116d250309cbe7bd39c0026ee016a.html">memory</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">basic_list.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="memory_2basic__list_8h_source.html">basic_list.h</a>&quot;</code><br />
<code>#include &lt;assert.h&gt;</code><br />
<code>#include &lt;stddef.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for basic_list.c:</div>
<div class="dyncontent">
<div class="center"><img src="memory_2basic__list_8c__incl.png" border="0" usemap="#memory_2basic__list_8c" alt=""/></div>
<map name="memory_2basic__list_8c" id="memory_2basic__list_8c">
<area shape="rect" id="node2" href="memory_2basic__list_8h.html" title="basic_list.h" alt="" coords="45,80,133,107"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ae9f64432b192455f316bf623574037a2"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#ae9f64432b192455f316bf623574037a2">list_insert</a> (void *ref, void *new, uint_least32_t pos)</td></tr>
<tr class="separator:ae9f64432b192455f316bf623574037a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07a470c76daa82462d543d42cbd1df36"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a07a470c76daa82462d543d42cbd1df36">list_insert_after</a> (void *ref, void *new)</td></tr>
<tr class="separator:a07a470c76daa82462d543d42cbd1df36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab742b7ea7cf853af670946a956a77192"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#ab742b7ea7cf853af670946a956a77192">list_remove</a> (void *ref, uint_least32_t pos)</td></tr>
<tr class="separator:ab742b7ea7cf853af670946a956a77192"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8f481baaa8c6fff21b9d435ad4e3a7b"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#ae8f481baaa8c6fff21b9d435ad4e3a7b">list_remove_next</a> (void *ref)</td></tr>
<tr class="separator:ae8f481baaa8c6fff21b9d435ad4e3a7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea35d033b336bc6e91afe59a63a22596"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#aea35d033b336bc6e91afe59a63a22596">list_next</a> (void *ref)</td></tr>
<tr class="separator:aea35d033b336bc6e91afe59a63a22596"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a9cf3ff042c1c58cf89cc68ccecdfcd"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a7a9cf3ff042c1c58cf89cc68ccecdfcd">list_prev</a> (void *ref, void *node)</td></tr>
<tr class="separator:a7a9cf3ff042c1c58cf89cc68ccecdfcd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a329055fb825862188f4108422398c30f"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a329055fb825862188f4108422398c30f">list_last</a> (void *ref)</td></tr>
<tr class="separator:a329055fb825862188f4108422398c30f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7da046fc29cdae90ff1f9c59cb9ef702"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a7da046fc29cdae90ff1f9c59cb9ef702">list_at</a> (void *ref, uint_least32_t pos)</td></tr>
<tr class="separator:a7da046fc29cdae90ff1f9c59cb9ef702"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbfd3b3116cdc3fcb38d86d37befabc8"><td class="memItemLeft" align="right" valign="top">int_least32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#afbfd3b3116cdc3fcb38d86d37befabc8">list_node_pos</a> (void *ref, void *node)</td></tr>
<tr class="separator:afbfd3b3116cdc3fcb38d86d37befabc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1c0f6e3cca52e060f4cce1248089d61"><td class="memItemLeft" align="right" valign="top">uint_least32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#ae1c0f6e3cca52e060f4cce1248089d61">list_length</a> (void *ref)</td></tr>
<tr class="separator:ae1c0f6e3cca52e060f4cce1248089d61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a4ab1f1570ecfceed96664f4a710635"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a1a4ab1f1570ecfceed96664f4a710635">list_insert_sorted</a> (void *ref, void *new, <a class="el" href="memory_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a> cmp)</td></tr>
<tr class="separator:a1a4ab1f1570ecfceed96664f4a710635"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a440f0519121756b356ecce7fd78993b1"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#a440f0519121756b356ecce7fd78993b1">list_sort</a> (void *ref, <a class="el" href="memory_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a> cmp)</td></tr>
<tr class="separator:a440f0519121756b356ecce7fd78993b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8b82bac744eb10143002e21c936795f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="memory_2basic__list_8c.html#ae8b82bac744eb10143002e21c936795f">list_foreach</a> (void *ref, <a class="el" href="memory_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">list_action_fp</a> action)</td></tr>
<tr class="separator:ae8b82bac744eb10143002e21c936795f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a7da046fc29cdae90ff1f9c59cb9ef702"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7da046fc29cdae90ff1f9c59cb9ef702">&#9670;&nbsp;</a></span>list_at()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_at </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_least32_t&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get node at position.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ref</td><td>Start node. </td></tr>
    <tr><td class="paramname">pos</td><td>Get node from position. 0 gets the first node. Values behind the list end will address the last list element. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Return node at pos. NULL if ref is NULL. </dd></dl>

</div>
</div>
<a id="ae8b82bac744eb10143002e21c936795f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8b82bac744eb10143002e21c936795f">&#9670;&nbsp;</a></span>list_foreach()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void list_foreach </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="memory_2basic__list_8h.html#a47b4e5df00566459624dd2f9628627e2">list_action_fp</a>&#160;</td>
          <td class="paramname"><em>action</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae9f64432b192455f316bf623574037a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9f64432b192455f316bf623574037a2">&#9670;&nbsp;</a></span>list_insert()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_insert </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>new</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_least32_t&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Insert node.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ref</td><td>Start node. Can be NULL if pos is 0. </td></tr>
    <tr><td class="paramname">node</td><td>Node to insert. Must not be NULL. </td></tr>
    <tr><td class="paramname">pos</td><td>Position to insert node at. 0 prepends. Values behind list end will append. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Return (possibly new) first node. </dd></dl>

</div>
</div>
<a id="a07a470c76daa82462d543d42cbd1df36"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07a470c76daa82462d543d42cbd1df36">&#9670;&nbsp;</a></span>list_insert_after()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void list_insert_after </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>new</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a1a4ab1f1570ecfceed96664f4a710635"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1a4ab1f1570ecfceed96664f4a710635">&#9670;&nbsp;</a></span>list_insert_sorted()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_insert_sorted </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>new</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="memory_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a>&#160;</td>
          <td class="paramname"><em>cmp</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Insert node in order. List must be alread sorted or contain only one other node.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ref</td><td>Start node. </td></tr>
    <tr><td class="paramname">new</td><td>Node to insert. </td></tr>
    <tr><td class="paramname">cmp</td><td>Function pointer to function used for comparision. end will append. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Return (possibly new) first node. </dd></dl>

</div>
</div>
<a id="a329055fb825862188f4108422398c30f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a329055fb825862188f4108422398c30f">&#9670;&nbsp;</a></span>list_last()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_last </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae1c0f6e3cca52e060f4cce1248089d61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1c0f6e3cca52e060f4cce1248089d61">&#9670;&nbsp;</a></span>list_length()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint_least32_t list_length </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aea35d033b336bc6e91afe59a63a22596"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aea35d033b336bc6e91afe59a63a22596">&#9670;&nbsp;</a></span>list_next()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_next </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="afbfd3b3116cdc3fcb38d86d37befabc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afbfd3b3116cdc3fcb38d86d37befabc8">&#9670;&nbsp;</a></span>list_node_pos()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int_least32_t list_node_pos </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>node</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a7a9cf3ff042c1c58cf89cc68ccecdfcd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a9cf3ff042c1c58cf89cc68ccecdfcd">&#9670;&nbsp;</a></span>list_prev()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_prev </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>node</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab742b7ea7cf853af670946a956a77192"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab742b7ea7cf853af670946a956a77192">&#9670;&nbsp;</a></span>list_remove()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_remove </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_least32_t&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae8f481baaa8c6fff21b9d435ad4e3a7b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8f481baaa8c6fff21b9d435ad4e3a7b">&#9670;&nbsp;</a></span>list_remove_next()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_remove_next </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a440f0519121756b356ecce7fd78993b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a440f0519121756b356ecce7fd78993b1">&#9670;&nbsp;</a></span>list_sort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* list_sort </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ref</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="memory_2basic__list_8h.html#a14311ae99d413fd70491ae0b4486acdd">list_compare_nodes_fp</a>&#160;</td>
          <td class="paramname"><em>cmp</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
